// Code generated by protoc-gen-connect-go. DO NOT EDIT.
//
// Source: locator/v1/locator.proto

package locatorv1connect

import (
	context "context"
	errors "errors"
	connect_go "github.com/bufbuild/connect-go"
	v1 "gitlab.com/wobcom/iot/hemingway-api/go/locator/v1"
	http "net/http"
	strings "strings"
)

// This is a compile-time assertion to ensure that this generated file and the connect package are
// compatible. If you get a compiler error that this constant is not defined, this code was
// generated with a version of connect newer than the one compiled into your binary. You can fix the
// problem by either regenerating this code with an older version of connect or updating the connect
// version compiled into your binary.
const _ = connect_go.IsAtLeastVersion0_1_0

const (
	// LocatorServiceName is the fully-qualified name of the LocatorService service.
	LocatorServiceName = "locator.v1.LocatorService"
)

// LocatorServiceClient is a client for the locator.v1.LocatorService service.
type LocatorServiceClient interface {
	Get(context.Context, *connect_go.Request[v1.GetRequest]) (*connect_go.Response[v1.GetResponse], error)
}

// NewLocatorServiceClient constructs a client for the locator.v1.LocatorService service. By
// default, it uses the Connect protocol with the binary Protobuf Codec, asks for gzipped responses,
// and sends uncompressed requests. To use the gRPC or gRPC-Web protocols, supply the
// connect.WithGRPC() or connect.WithGRPCWeb() options.
//
// The URL supplied here should be the base URL for the Connect or gRPC server (for example,
// http://api.acme.com or https://acme.com/grpc).
func NewLocatorServiceClient(httpClient connect_go.HTTPClient, baseURL string, opts ...connect_go.ClientOption) LocatorServiceClient {
	baseURL = strings.TrimRight(baseURL, "/")
	return &locatorServiceClient{
		get: connect_go.NewClient[v1.GetRequest, v1.GetResponse](
			httpClient,
			baseURL+"/locator.v1.LocatorService/Get",
			opts...,
		),
	}
}

// locatorServiceClient implements LocatorServiceClient.
type locatorServiceClient struct {
	get *connect_go.Client[v1.GetRequest, v1.GetResponse]
}

// Get calls locator.v1.LocatorService.Get.
func (c *locatorServiceClient) Get(ctx context.Context, req *connect_go.Request[v1.GetRequest]) (*connect_go.Response[v1.GetResponse], error) {
	return c.get.CallUnary(ctx, req)
}

// LocatorServiceHandler is an implementation of the locator.v1.LocatorService service.
type LocatorServiceHandler interface {
	Get(context.Context, *connect_go.Request[v1.GetRequest]) (*connect_go.Response[v1.GetResponse], error)
}

// NewLocatorServiceHandler builds an HTTP handler from the service implementation. It returns the
// path on which to mount the handler and the handler itself.
//
// By default, handlers support the Connect, gRPC, and gRPC-Web protocols with the binary Protobuf
// and JSON codecs. They also support gzip compression.
func NewLocatorServiceHandler(svc LocatorServiceHandler, opts ...connect_go.HandlerOption) (string, http.Handler) {
	mux := http.NewServeMux()
	mux.Handle("/locator.v1.LocatorService/Get", connect_go.NewUnaryHandler(
		"/locator.v1.LocatorService/Get",
		svc.Get,
		opts...,
	))
	return "/locator.v1.LocatorService/", mux
}

// UnimplementedLocatorServiceHandler returns CodeUnimplemented from all methods.
type UnimplementedLocatorServiceHandler struct{}

func (UnimplementedLocatorServiceHandler) Get(context.Context, *connect_go.Request[v1.GetRequest]) (*connect_go.Response[v1.GetResponse], error) {
	return nil, connect_go.NewError(connect_go.CodeUnimplemented, errors.New("locator.v1.LocatorService.Get is not implemented"))
}
